# coding=utf-8
import codecs
import json
import time
from argparse import ArgumentParser

import pandas as pd
from tweepy import OAuthHandler, TweepError, RateLimitError
from tweepy import API

token = {
        "access_token": "",
        "access_token_secret": "",
        "consumer_key": "",
        "consumer_secret": "",
    }


if __name__ == '__main__':
    parser = ArgumentParser()
    parser.add_argument('--input', type=str, help='input file')
    parser.add_argument('--output', type=str, help='output file')
    args = parser.parse_args()

    df = pd.read_csv(args.input, dtype={'tweet_id': 'str'}, sep="\t")
    print(df.shape)

    auth = OAuthHandler(token.get("consumer_key"), token.get("consumer_secret"))
    auth.set_access_token(token.get("access_token"), token.get("access_token_secret"))
    auth_api = API(auth)

    with codecs.open(args.output, "w", encoding="utf8") as f:
        for index, row in df.iterrows():
            try:
                tweet = auth_api.get_status(row["tweet_id"])._json
                tweet["label"] = row["label"]
                f.write(json.dumps(tweet, ensure_ascii=False) + "\n")
                print(index)
                if index % 900 == 0:
                    time.sleep(900)
            except RateLimitError as e:
                print(e.response.reason)
            except TweepError:
                print("Not found: " + row["tweet_id"])
